/*
 * 分仓机具额度记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class StoreHouseAmountRecordController : BaseController
    {
        public StoreHouseAmountRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 分仓机具额度记录列表

        /// <summary>
        /// 根据条件查询分仓机具额度记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(StoreHouseAmountRecord data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询分仓机具额度记录列表

        /// <summary>
        /// 分仓机具额度记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(StoreHouseAmountRecord data, string UserIdRealName, string UserIdMakerCode, string AmountTypeSelect, string OperateTypeSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
            }
            //创客创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UsersForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //额度类别
            if (!string.IsNullOrEmpty(AmountTypeSelect))
            {
                condition += " and AmountType=" + AmountTypeSelect;
            }
            //操作类别
            if (!string.IsNullOrEmpty(OperateTypeSelect))
            {
                condition += " and OperateType=" + OperateTypeSelect;
            }


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("StoreHouseAmountRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic.Remove("UserId");
                //申请单
                dic["ApplyId"] = RelationClass.GetStoreMachineApplyInfo(int.Parse(dic["ApplyId"].ToString()));
                //额度类别
                int AmountType = int.Parse(dic["AmountType"].ToString());
                if (AmountType == 0) dic["AmountType"] = "固定额度";
                if (AmountType == 1) dic["AmountType"] = "临时额度";
                //操作类别
                int OperateType = int.Parse(dic["OperateType"].ToString());
                if (OperateType == 1) dic["OperateType"] = "增加";
                if (OperateType == 2) dic["OperateType"] = "减少";
                if (OperateType == 0) dic["OperateType"] = "";

            }
            return Json(obj);
        }

        #endregion

        #region 增加分仓机具额度记录

        /// <summary>
        /// 增加或修改分仓机具额度记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加分仓机具额度记录

        /// <summary>
        /// 增加或修改分仓机具额度记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(StoreHouseAmountRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("OperateType", data.OperateType); //操作类别

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("StoreHouseAmountRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "StoreHouseAmountRecord", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改分仓机具额度记录

        /// <summary>
        /// 增加或修改分仓机具额度记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            StoreHouseAmountRecord editData = db.StoreHouseAmountRecord.FirstOrDefault(m => m.Id == Id) ?? new StoreHouseAmountRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改分仓机具额度记录

        /// <summary>
        /// 增加或修改分仓机具额度记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(StoreHouseAmountRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("OperateType", data.OperateType); //操作类别

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreHouseAmountRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "StoreHouseAmountRecord", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除分仓机具额度记录信息

        /// <summary>
        /// 删除分仓机具额度记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "StoreHouseAmountRecord", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreHouseAmountRecord", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "StoreHouseAmountRecord", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreHouseAmountRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "StoreHouseAmountRecord", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreHouseAmountRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Sort("StoreHouseAmountRecord", Sort, Id);

            AddSysLog(Id.ToString(), "StoreHouseAmountRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.StoreHouseAmountRecord.Add(new StoreHouseAmountRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "StoreHouseAmountRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(StoreHouseAmountRecord data, string UserIdRealName, string UserIdMakerCode, string AmountTypeSelect, string OperateTypeSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
            }
            //创客创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UsersForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //额度类别
            if (!string.IsNullOrEmpty(AmountTypeSelect))
            {
                condition += " and AmountType=" + AmountTypeSelect;
            }
            //操作类别
            if (!string.IsNullOrEmpty(OperateTypeSelect))
            {
                condition += " and OperateType=" + OperateTypeSelect;
            }


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("StoreHouseAmountRecord", Fields, "Id desc", "0", 1, 20000, condition, "UserId,ApplyId,UseAmount,BeforeAmount,AfterAmount,AmountType,OperateType", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic.Remove("UserId");
                //申请单
                dic["ApplyId"] = RelationClass.GetStoreMachineApplyInfo(int.Parse(dic["ApplyId"].ToString()));
                //额度类别
                int AmountType = int.Parse(dic["AmountType"].ToString());
                if (AmountType == 0) dic["AmountType"] = "固定额度";
                if (AmountType == 1) dic["AmountType"] = "临时额度";
                //操作类别
                int OperateType = int.Parse(dic["OperateType"].ToString());
                if (OperateType == 1) dic["OperateType"] = "增加";
                if (OperateType == 2) dic["OperateType"] = "减少";
                if (OperateType == 0) dic["OperateType"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("UserIdMakerCode", "创客创客编号");
            ReturnFields.Add("ApplyId", "申请单");
            ReturnFields.Add("UseAmount", "使用额度");
            ReturnFields.Add("BeforeAmount", "使用前剩余额度");
            ReturnFields.Add("AfterAmount", "使用后剩余额度");
            ReturnFields.Add("AmountType", "额度类别");
            ReturnFields.Add("OperateType", "操作类别");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "StoreHouseAmountRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
